Attribute VB_Name = "SlsApiEx"
' This is a part of the Sheriff System Development Kit.
' Copyright (C) 1997-1998 Acudata Limted.
' All rights reserved.
'
' This source code is only intended as a supplement to the
' Sheriff System Development Kit and related
' electronic documentation provided with the SDK.

Public Const SLSKEY_SUCCESS = 0
Public Const SLSKEY_ERROR = 1
Public Const SLSKEY_E_BAD_PRODUCT_ID = 2
Public Const SLSKEY_E_BAD_REFERENCE = 3
Public Const SLSKEY_E_BAD_PID_REF = 4   'Reference code does not match product ID
Public Const SLSKEY_E_BAD_LICENCE_TYPE = 5
Public Const SLSKEY_E_BAD_LICENCE_DATE = 6
Public Const SLSKEY_E_BAD_SECRET_SIZE = 10
Public Const SLSKEY_E_BAD_SECRET_1 = 11
Public Const SLSKEY_E_BAD_SECRET_2 = 12
Public Const SLSKEY_E_BAD_SECRET_3 = 13
Public Const SLSKEY_E_BAD_SECRET_4 = 14


Type SLS_DATE
    Year    As Long
    Month   As Long
    Day     As Long
End Type

Type SLS_LICENCE
    Type    As Long
    Meter   As Long
    EndDate As SLS_DATE
    CoUsers As Long
    AccessKey As Long
End Type

Type SLS_SECRET
    Secret(128) As Byte
End Type

Declare Function SLS_GenerateLicenceKey Lib "SlsApiEx" ( _
            ByVal lpszProductID As String, _
            ppSecretArray As SLS_SECRET, _
            ByVal nSecretSize As Integer, _
            ByVal lpszReferenceCode As String, _
            pLicencePolicy As SLS_LICENCE, _
            ByVal lpszLicenceKey As String) As Integer
            
Public Sub SetSecrets(Secrets As Variant)
    Dim nIdx As Integer
    nIdx = 0
    For i = 0 To 3
        For j = 0 To 17
            m_arySecrets.Secret(nIdx) = Secrets(i * 18 + j)
            nIdx = nIdx + 1
        Next j
        For j = 18 To 31
            m_arySecrets.Secret(nIdx) = 0
            nIdx = nIdx + 1
        Next j
        
    Next i
End Sub

Public Sub SetSecretsNE(ByVal Secret1 As String, ByVal Secret2 As String, ByVal Secret3 As String, ByVal Secret4 As String)
    Dim strSecrets As String
    Padding = "123456789012"
    strSecrets = Secret1 + Chr$(0) + Padding + Secret2 + Chr$(0) + Padding + Secret3 + Chr$(0) + Padding + Secret4 + Chr$(0) + Padding

     Dim i As Integer
     Dim bt As Byte
     For i = 1 To Len(strSecrets)
         bt = Asc(Mid(strSecrets, i, 1))
         m_arySecrets.Secret(i - 1) = bt
     Next i


End Sub

